#include <vector>
#include <cstdio>
#include <cstdlib>

extern std::vector<int> testset(std::vector<int> A, std::vector<int> B, std::vector<int> L, std::vector<int> U);

void my_assert (bool x) {
	if (!x) {
		puts("Wrong input");
		exit(0);
	}
}

int main()
{
	int N, M;

	my_assert(scanf("%d %d", &N, &M) == 2);
	std::vector<int> A(N), B(N - 1), L(M), U(M);

	for (int i = 0; i < N; i++) my_assert(scanf("%d", &A[i]) == 1);
	for (int j = 0; j < N-1; j++) my_assert(scanf("%d", &B[j]) == 1);
	for (int i = 0; i < M; i++) my_assert(scanf ("%d %d", &L[i], &U[i]) == 2);

	std::vector<int> S = testset(A, B, L, U);
	if ((int)S.size() != M) {
		printf("Size of S should be %d, but it is %d\n", M, (int)S.size());
		return 0;
	}

	for (int& s : S) printf ("%d\n",s);

	return 0;
}
